'------------------------------------------------------------
'			AddAudioFile.vbs
'  Scan the current album and add wav audio files that match
'  (in a specified sub-folder) the picture names.
'------------------------------------------------------------

Option Explicit

app.ClearTrace

' Define the variables
dim alb, nb, i, pic, fs, sAudio, sSoundFolder

' The sounds are located in the sSoundFolder folder
sSoundFolder = ""

Set fs = CreateObject("Scripting.FileSystemObject")
set alb = app.GetCurrentAlbum

nb = alb.nbPicture
app.Trace "Pictures in this album: " & nb
for i=0 to nb-1
    ' Process each picture
    Set pic = alb.GetPicture(i)
    app.trace pic.sShortFileName & " - " & pic.sCommentFirstLine
    sAudio = CheckFile( pic.sFileName, "wav", sSoundFolder )
    if sAudio = "" then
      sAudio = CheckFile( pic.sFileName, "mp3", sSoundFolder )
    end if
    if sAudio <> "" then
      app.trace "   Audio file found !!!   " & sAudio
      pic.sPlayCmd = "media|" & sAudio
    end if
next

app.Trace "Done !"

function CheckFile( sF, sType, sFolder )
  dim k, sAudio, oFile, kS

  sAudio = sF
  k = InStrRev( sAudio, "." )
  sAudio = left( sAudio, k ) & sType
  ' if a folder name is specified, insert it before the filename
  if sFolder <> "" then
    kS = InStrRev( sAudio, "\" )
    sAudio = left( sAudio, kS ) & sFolder & mid( sAudio, kS )
  end if
  if fs.FileExists( sAudio ) then
    CheckFile = sAudio
  else
    CheckFile = ""
  end if
end function
