' ------------------------------------------------------------------------------------
'                        Add_JPS_Shortcuts.vbs
' This script will create keyboard shortcuts for easily controlling the MAX_JPSView
' extension.
' Press the Ctrl key and one of number key on the top of the keyboards
'
'   Ctrl-0    display the pictures side by side.
'   Ctrl-1    display only one picture.
'   Ctrl-2    display the pictures one on the top of the other (KMQ, over/under).
'   ---removed------------Ctrl-3    display a B&W anaglyph.
'   Ctrl-4    cycle between color anaglyph and B&W anaglyph (for red-cyan glasses).
'   Ctrl-5    swap left and right pictures. 
'   Ctrl-6    mirror the first picture.
'   Ctrl-7    mirror the second picture.
'   Ctrl-8    display a horizontaly interlaced image (should be used with zoom 1:1).
'   Ctrl-9    back to the default setting (no mirror, no swap, side by side).
' ------------------------------------------------------------------------------------
option explicit

' Change this constant if MyAlbum is not installed in this folder:
const sMyAlbumlFolder = "C:\Program Files\MyAlbum\"

app.AddCustomTool ">JPS side by side", 	 "1|" & sMyAlbumlFolder & "ChangeJPSMax_Par.vbs",  	48, 2, True
app.AddCustomTool ">JPS one picture",  	 "1|" & sMyAlbumlFolder & "ChangeJPSMax_Mono.vbs", 	49, 2, True
app.AddCustomTool ">JPS over/under",  	 "1|" & sMyAlbumlFolder & "ChangeJPSMax_HB.vbs",   	50, 2, True
'app.AddCustomTool ">JPS Gray anaglyph",  "1|" & sMyAlbumlFolder & "ChangeJPSMax_GrAna.vbs",   	51, 2, True
app.AddCustomTool ">JPS Anaglyph", 	 "1|" & sMyAlbumlFolder & "ChangeJPSMax_Anaglyph.vbs", 	52, 2, True
app.AddCustomTool ">JPS Swap pictures",  "1|" & sMyAlbumlFolder & "ChangeJPSMax_Swap.vbs",   	53, 2, True
app.AddCustomTool ">JPS Mirror Pic 1",   "1|" & sMyAlbumlFolder & "ChangeJPSMax_Mirror1.vbs",  	54, 2, True
app.AddCustomTool ">JPS Mirror Pic 2",   "1|" & sMyAlbumlFolder & "ChangeJPSMax_Mirror2.vbs",  	55, 2, True
app.AddCustomTool ">JPS H Interlace",    "1|" & sMyAlbumlFolder & "ChangeJPSMax_HInterlace.vbs",56, 2, True
app.AddCustomTool ">JPS Restore default","1|" & sMyAlbumlFolder & "ChangeJPSMax_Default.vbs",  	57, 2, True


App.Trace "Done!", -1, TRACE_GREENDOT
