' ------------------------------------------------------------------------------------
'					AutoTOC
' This script builds a HTML table of content for the current album and place 
' it at the beginning of the album.
' ------------------------------------------------------------------------------------

Option Explicit

  app.ClearTrace

  Dim alb, pic
  set alb = app.GetCurrentAlbum
  Dim outputFileName
  outputFileName = Replace( alb.FullName, ".alb", ".html" )
  app.Trace "Output file = " & outputFileName

  Const ForReading = 1, ForWriting = 2

  Dim fso, f, m
  Set fso = CreateObject("Scripting.FileSystemObject")
  Set f = fso.OpenTextFile( outputFileName, ForWriting, True)
  f.WriteLine "<HTML>" 
  f.WriteLine "<Head>" 
  f.WriteLine "   <META HTTP-EQUIV=""Content-Type"" CONTENT=""text/html; charset=iso-8859-1"">"
  f.WriteLine "   <META NAME=""Generator"" CONTENT=""MyAlbum"">"
  f.WriteLine "   <title> " & alb.sAlbumTitle & " - " & alb.sAlbumComment & "</title>"
  f.WriteLine "</Head>" 
  f.WriteLine "<BODY TEXT=#0000a0 BGCOLOR=#c0c0c0>"
  f.WriteLine "<h1><center>" & alb.sAlbumTitle & "</center></h1>"
  f.WriteLine "<h2><center>" & alb.sAlbumComment & "</center></h2>"

  ' Process each picture
  Dim nbPic, i, s
  nbPic = alb.nbPicture
  app.Trace "Pictures in this album: " & nbPic


  f.WriteLine "<table>"
  for i=0 to nbPic-1
      Set pic = alb.GetPicture(i)
      if pic.sFileName <> outputFileName then
	f.WriteLine "<tr><td><IMG SRC=""bullet.gif""></td>"
	f.WriteLine "    <td><font size=+2><a href=""myalbum://gotopic=" & pic.sShortFileName & """> " & alb.ExpandMacro( pic, "%BF" ) & "</a></font></td>"
	f.WriteLine "    <td><font size=+1>" & pic.sCommentFirstLine & "</font></td>"
	f.WriteLine "</tr>"
      end if
    next
    f.WriteLine "</table>"

    f.WriteLine "<center>Build with MyAlbum script</center>"
    f.WriteLine "</BODY>"
    f.WriteLine "</html>"

    f.Close

    app.Trace nbPic & " picture processed"

    set pic = alb.addPicture( outputFileName )
    alb.movePicture pic, 0, FALSE

    app.Trace "HTML file generation complete !"
