'---------------------------------------------------------------------------------
'				BuildVideoTh.vbs
' This script is used to replace the default thumbnail used for the video files
' with a screenshot taken from the video.
' Associate this script to a keyword shortcut.
' When viewing the video, press the shortcut to capture the current video frame
' (in non DirectShow mode).
' It can be also be used from the thumbnail view, to replace the thumbnail of any
' picture of the album with an arbitrary picture placed on the Windows clipboard.
'---------------------------------------------------------------------------------
Option Explicit

Dim alb, pic
set alb = app.GetCurrentAlbum

if not alb is nothing then
  set pic = alb.GetVisiblePicture( alb.nCurrentPicture )
  if not pic is nothing then

    ' If we are in full-screen mode, copy the current frame (or picture) to the clipboard
    if not app.GetFullScreenView is nothing then pic.copy( 0 )

    ' Paste the content of the clipboard to the thumbnail
    pic.pasteToThumbnail True
    alb.ReDraw
  end if
end if

