' ------------------------------------------------------------------------------------
' This is a simple HTML generator written in VBScript
'
'    It uses the current album or a user specified album to build a Framed HTML file.
'    This file processes all the selected pictures.
' ------------------------------------------------------------------------------------

Option Explicit

' To run this script outside of MyAlbum, un-comment the 2 following lines:
'dim app
'set app = CreateObject("MyAlbum.Application")

app.ClearTrace


Dim alb, pic
if GetAlbum( alb ) then

    MsgBox( "This script will add the selected pictures to a Framed HTML page.  Please select OK to continue")

    MsgBox( "If you want alternate text to show when mouse is over the thumbnail, First fill out the Information field for each pic in the album by right mouse clicking on the pic and selecting Information.  Please select OK to continue")
    'app.Trace "Output file = " & outputFileName

    Dim outputFileName
    outputFileName = InputBox( "Please enter the name of the INDEX HTML file to create", "Simple HTML generator", "index.html")
    app.Trace "Output file = " & outputFileName

    Dim backgroundcolor
    backgroundcolor = InputBox( "Please enter the color for the background, choices are: black, white, green, blue, red", "Simple HTML generator", "white")
    app.Trace "Background Color = " & backgroundcolor

    Dim fontcolor
    fontcolor = InputBox( "Please enter the color for the font, choices are: black, white, green, blue, red", "Simple HTML generator", "black")
    app.Trace "Font Color = " & fontcolor

    Dim titlename
    titlename = InputBox( "Please enter the Title of the web page to create", "Simple HTML generator", alb.sAlbumTitle )
    app.Trace "Web Page Title = " & titlename

    Dim maintext
    maintext = InputBox( "Please enter a text description to display in the main window of the web page to create", "Simple HTML generator", "description" )
    app.Trace "Web Page Description = " & maintext

    Const ForReading = 1, ForWriting = 2

    Dim fso, f, m, picPath
    Set fso = CreateObject("Scripting.FileSystemObject")

' This part works and picPath is equal to the absolute path and pic file name.
' First get the path relative to the album
    Set pic = alb.GetVisiblePicture(0)
    picPath = alb.ExpandMacro( pic, "%RP" )
    app.Trace "The path for the first picture is " & picPath
    dim k, pathstring
    k = instrrev(picPath,"\") 		' Search for the last back-slash
    pathstring = left(picPath, k)
    app.Trace "The pathstring is " & pathstring

    Set f = fso.OpenTextFile( pathstring & outputFileName, ForWriting, True)
    f.WriteLine "<HTML>" 
    f.WriteLine "<Head>" 
    f.WriteLine "   <META HTTP-EQUIV=""Content-Type"" CONTENT=""text/html; charset=iso-8859-1"">"
    f.WriteLine "   <META NAME=""Generator"" CONTENT=""MyAlbum"">"
    f.WriteLine "   <title> " & titlename & "</title>"
    f.WriteLine "</Head>" 
    f.WriteLine "<frameset framespacing=0 border=false rows=56,* frameborder=0>"
    f.WriteLine "<frame name=""banner"" scrolling=no noresize target=""contents"" src=""top.html"" marginheight=8>"
    f.WriteLine "<frameset cols=190,*>"
    f.WriteLine "<frame name=""contents"" target=main src=""menu.html"">"
    f.WriteLine "<frame name=""main"" src=""main.html"" scrolling=auto marginwidth=0 marginheight=0>"
    f.WriteLine "</frameset>"
    f.WriteLine "<noframes>"
    f.WriteLine "<BODY TEXT=" & fontcolor & " BGCOLOR=" & backgroundcolor & ">"
    f.WriteLine "<p>This page requires a frames capable browser</p>"
    f.WriteLine "</body>"
    f.WriteLine "</noframes>"
    f.WriteLine "</frameset>"
    f.WriteLine "</html>"
    app.Trace "Page " & outputfilename & " created "
    f.Close
'
' This section creates the top.html file
'
'    Set topFileName = top.html
    Set f = fso.OpenTextFile( pathstring  & "top.html", ForWriting, True)
    f.WriteLine "<HTML>" 
    f.WriteLine "<Head>" 
    f.WriteLine "<base target=contents>"
    f.WriteLine "<title>top</title>"
    f.WriteLine "</Head>" 
    f.WriteLine "<BODY TEXT=""" & fontcolor & """ BGCOLOR=""" & backgroundcolor & """>"
    f.WriteLine "<p><big><big><big><font face=Arial><strong><Center> " & titlename & " </Center></strong></font></big></big></big></p>"
    f.WriteLine "</body>"
    f.WriteLine "</html>"
    app.Trace "Page top.html created "
    f.Close
'
' This section creates the main.html file
'
    Set f = fso.OpenTextFile( pathstring & "main.html", ForWriting, True)
    f.WriteLine "<HTML>" 
    f.WriteLine "<Head>" 
    f.WriteLine "<title>main</title>"
    f.WriteLine "</Head>" 
    f.WriteLine "<BODY LEFTMARGIN=0 TOPMARGIN=0 TEXT=""" & fontcolor & """ BGCOLOR=""" & backgroundcolor & """>"
    f.WriteLine "<br><br><br><br><Center>"
    f.WriteLine "<table border=0 cellpadding=0 width=70%>"
    f.WriteLine "<tr>"
    f.WriteLine "<td width=100% colspan=2 align=left>"
    f.WriteLine "<big><big><big><font face=Arial><strong><Center>" & maintext & " </Center></strong></font></big></big></big></p>"
    f.WriteLine "</td></tr></table></center>"
    f.WriteLine "</body>"
    f.WriteLine "</html>"
    app.Trace "Page main.html created "
    f.Close
'
'
' This section creates the menu.html file
'
    Set f = fso.OpenTextFile( pathstring & "menu.html", ForWriting, True)
    f.WriteLine "<HTML>" 
    f.WriteLine "<Head>" 
    f.WriteLine "   <title> " & titlename & "</title>"
    f.WriteLine "<base target=main>"
    f.WriteLine "</Head>" 
    f.WriteLine "<BODY TEXT=""" & fontcolor & """ BGCOLOR=""" & backgroundcolor & """>"
    f.WriteLine "<small><small><blink>Click Here</blink><br></small></small>"
    f.WriteLine "<div align=left>"

    app.Trace "Page menu.html being created "

'
'
' The following lines go to the creation of the MENU files
'
'
    ' Process each selected picture
    Dim nbPic, i
    nbPic = alb.nbVisiblePicture
    app.Trace "Pictures to process in this album: " & nbPic

    f.WriteLine "<br><center>"	' Everything is centered
    for i=0 to nbPic-1
        Set pic = alb.GetVisiblePicture(i)
          if pic.bSelected then

            f.WriteLine "<table border=1 cellpadding=4 width=100%>"
            f.WriteLine "<tr>"
   
            ' Important : convert the filename so it is web-compatible
            Dim picFile, thFile
            ' First get the path relative to the album
            picFile = alb.ExpandMacro( pic, "%RP" )
            ' Build the name of the thumbnail assuming "_th" is appended
	    ' to the name and its type is the same as the original picture
            k = instrrev( picFile, "." )
	    thFile = left(picFile, k-1) & "_th" & mid(picFile, k)

            f.WriteLine "<td width=100% colspan=2 align=center><A HREF=""" & app.HTMLFileName(picFile, pathstring ) & """><IMG SRC=""" & app.HTMLFileName(thFile, pathstring ) & """ border=0 ALT=""" & pic.sCommentFirstLine & """></td>"
            f.WriteLine "</tr>"
            f.WriteLine "</table>"

	    ' Build the drop-down list with the picture info
	    picFile = pic.sShortFileName
            'f.WriteLine "<TABLE border=0 cellPadding=0>"
            'f.WriteLine "  <TBODY>"
            'f.WriteLine "  <TR>"
            'f.WriteLine "   <TD><FONT face=arial size=-2>"
            'f.WriteLine "   <FORM>"
            f.WriteLine "<SELECT name=""" & picFile & """ size=1>" & picFile
            f.WriteLine " <OPTION selected value=Name>Name " & picFile & "</OPTION>"
            f.WriteLine " <OPTION value=Resolution>Resolution " & pic.w & "x" & pic.h & "</OPTION>"
            f.WriteLine " <OPTION value=Size>Size " & round(pic.dwFileSize / 1024) & " KB</OPTION>"
            f.WriteLine " <OPTION value=Shutter>Shutter " & alb.ExpandMacro(pic, "%C4") & "</OPTION>"
            f.WriteLine " <OPTION value=Zoom>Zoom " & alb.ExpandMacro(pic, "%C6") & "</OPTION>"
            f.WriteLine " <OPTION value=Exposure>Exposure " & alb.ExpandMacro(pic, "%C3") & "</OPTION>"
            'f.WriteLine " <OPTION value=FocusD>Focus Dist 5000 "  & alb.ExpandMacro(pic, "%C1") &  " </OPTION>"
            'f.WriteLine " <OPTION value=Focus>Focus Multi-Spot "  & alb.ExpandMacro(pic, "%C2") &  " </OPTION>"
            f.WriteLine " <OPTION value=Flash>Flash " & alb.ExpandMacro(pic, "%C5") & "</OPTION>"
            'f.WriteLine " <OPTION value=Compression>Compression Best "  & alb.ExpandMacro(pic, "%C1") &  " </OPTION>"
            f.WriteLine "</SELECT>"
            'f.WriteLine "   </FORM>"
            'f.WriteLine "   </FONT></TD></TR></TBODY>"
            'f.WriteLine "</TABLE>"
	    f.WriteLine "<br>"
            app.Trace "File " & picFile & " added"
          else
            app.Trace "File " & picFile & " skipped"
          end if
    next

    f.WriteLine "</center>"

    f.WriteLine "<small><small>Built with MyAlbum script"
    f.WriteLine "<font color=""#FF0000""><BR>Created by:"
    f.WriteLine "<BR>mpilihp@yahoo.com"
    f.WriteLine "<BR>With help by:"
    f.WriteLine "<BR>pierre.meindre@wanadoo.fr"
    f.WriteLine "<BR>With code from:"
    f.WriteLine "<BR>r.p.feria@ieee.org"
    f.WriteLine "<BR>Steve@sdean.demon.co.uk</font></small></small>"

    f.WriteLine "</BODY>"
    f.WriteLine "</HTML>"

    f.Close

    app.Trace nbPic & " picture processed."
    app.Trace "HTML file generation complete !"
    app.Trace "This script creates a web page that uses thumbnail pictures in the menu."
    app.Trace "Create these from My Album Tools -> Export Album menu option."
    app.Trace "Select -Save Thumbnails- then set Output Directory to where this albums images are located, and prest Start!"

    MsgBox( "Please read the last three lines in trace for instructions on completing this WEB page." & vbcrlf & "Please select OK to continue")

    ' Launch browser
    app.Run pathstring & outputFileName, True, 1

else
    app.Trace "No album to process, exiting !"
end if

' ********************************************************************************
' *
' * GetAlbum : get the current album or prompt the user to select one
' *
Function GetAlbum( byref alb )
    GetAlbum = True
    ' First try to use the current album
    set alb = app.GetCurrentAlbum
    if alb is nothing then	' No album is open
        dim albFile
        albFile = InputBox( "Please enter the name of the album to process", "Simple HTML generator", "")
        set alb = app.LoadAlbum( albFile )
        if alb is Nothing then
            GetAlbum = False
        end if
    end if
End Function

