' ------------------------------------------------------------------------------------
'				JavascriptHTMLSlideshow.vbs
' This script will generate an HTML slideshow with some javascript code to do the
' animation.
' The generated code uses standard DHTML code and will run under Netscape 6, IE
' and Konqueror.
' The HTML file will be written in the folder where the album file is present.
' Note: Pictures are loaded in memory as they are displayed so big slideshows will
'	consume all available memory. Pictures are then freed and only the last 
'	nbMaxPictureToKeep pictures are kept.
' ------------------------------------------------------------------------------------

Option Explicit

app.ClearTrace

const titleText = "%AN"			' Display String for page title
'const pictureText = "%FN (%FK KB)"	' Display String for the picture comment
'const pictureText = "%C7 - %1C%|%C1 %C2"
const pictureText = "%C8 - %1C - %C1 %LE[%C2,5]"
const selectText = "%p# - %C8 - %1C - %C1 %LE[%C2,5]"	' Set it to an empty string to remove the selection drop-down list
'const selectText = "%p# - %C7 - %1C - %C1 %C2"	' Set it to an empty string to remove the selection drop-down list
const nbMaxPictureToKeep = 5
const bShowPicNumber = TRUE		' Display the current picture number with the comment
const nFastForwardStep = 5		' How many picture to skip with the >> and << buttons

Dim alb, pic, fso, f, sAlbumPath, k
set alb = app.GetCurrentAlbum
sAlbumPath = alb.ExpandMacro( Nothing, "%Af" )

Dim outputFileName, sTitle
outputFileName = "Slideshow.html" 'InputBox( "Please enter the name of the HTML file to create", "JavascriptHTMLSlideshow generator", "JavascriptSlideshow.html")
outputFileName = sAlbumPath & "\" & outputFileName 
app.Trace "Output file = " & outputFileName, -1, TRACE_INFORMATION

Const ForReading = 1, ForWriting = 2

Dim nbPic, i, w, nbSelPic, sFirstPic, s, sCmt, duration, ixPic
nbPic = alb.nbPicture
nbSelPic = alb.nbSelectedPicture
app.Trace "Pictures selected in this album: " & nbSelPic, -1, TRACE_INFORMATION


Set fso = CreateObject("Scripting.FileSystemObject")
Set f = fso.OpenTextFile( outputFileName, ForWriting, True)
f.WriteLine "<!DOCTYPE html PUBLIC ""-//W3C//DTD HTML 4.01 Transitional//EN"">"
f.WriteLine "<html>"
f.WriteLine "<head>"
sTitle = alb.ExpandMacro( Nothing, titleText )
f.WriteLine " <title>" & sTitle & "</title>"
f.WriteLine " <META HTTP-EQUIV=""Content-Type"" CONTENT=""text/html; charset=UTF-8"">"
f.WriteLine " <META NAME=""Generator"" CONTENT=""MyAlbum"">"
f.WriteLine " <meta name=""description"" content=""Generated by MyAlbum " & alb.ExpandMacro(Nothing,"%MV") & ". http://www.MyAlbumPro.com"">"
f.WriteLine ""
f.WriteLine "<!-- MyAlbum Script Copyright  2003-04 Pierre MEINDRE -->"
f.WriteLine "<script LANGUAGE=JAVASCRIPT>"
' Define some javascript functions and the CMyPicture class that will hold the pictures info
f.WriteLine "function CMyPicture( filename, comment, width, height, duration )"
f.WriteLine "{"
f.WriteLine "  this.length = 6;   		// Number of properties in the object, not including this one."
f.WriteLine "  this.filename = filename;	// File name (or URL) of the picture"
f.WriteLine "  this.comment  = comment;	// Comment displayed with the picture"
f.WriteLine "  this.w        = width;	// Width of the picture"
f.WriteLine "  this.h        = height;	// Height of the picture"
f.WriteLine "  this.duration = duration;	// Duration"
f.WriteLine "  this.image    = null;"
f.WriteLine "}" & vbcrlf

f.WriteLine "function addPicture( newPic )  // Define a function to extend the list."
f.WriteLine "{"
f.WriteLine "  this.length += 1;			// Increment the length of the array."
f.WriteLine "  this[(this.length-1)] = newPic;	// Add the new item, maintaining item numbering."
f.WriteLine "}" & vbcrlf

f.WriteLine "function pictureList()"
f.WriteLine "{"
f.WriteLine "  this.length = 0;"
f.WriteLine "  this.addPicture = addPicture;   	// Include the addPicture function as a method."
f.WriteLine "}" & vbcrlf

f.WriteLine "function doSlideShow()"
f.WriteLine "{"
f.WriteLine "  // Load picture to image object if it has not been read already"
f.WriteLine "  if (myPictureList[nCurrentPic].image == null) {"
f.WriteLine "    myPictureList[nCurrentPic].image = new Image();"
f.WriteLine "    myPictureList[nCurrentPic].image.src = myPictureList[nCurrentPic].filename;"
f.WriteLine "  }"
f.WriteLine "  // Do some clean-up or the web browser will keep all pictures in memory"
f.WriteLine "  var k = nCurrentPic - 5;"
f.WriteLine "  if (k < 0) k += " & nbSelPic & ";"
f.WriteLine "  if (myPictureList[k].image != null) {"
f.WriteLine "    delete myPictureList[k].image;"
f.WriteLine "    myPictureList[k].image = null;"
f.WriteLine "  }" & vbcrlf

f.WriteLine "  // Display the current picture in the document"
if True then
f.WriteLine "  var s = '<img id=thePicture src=""' + myPictureList[nCurrentPic].image.src + '"" align=""middle"" valign=""center""';"
f.WriteLine "  if (myPictureList[nCurrentPic].w > myPictureList[nCurrentPic].h)"
f.WriteLine "    s += 'width=""90%"">';"
f.WriteLine "  else"
f.WriteLine "    s += 'height=""80%"">';"
f.WriteLine "  document.getElementById(""thePic"").innerHTML = s;"
else
f.WriteLine "  thePicture.src = """";"
f.WriteLine "  thePicture.src = myPictureList[nCurrentPic].image.src;"
f.WriteLine "  var wD = theDiv.clientWidth;"
f.WriteLine "  var hD = theDiv.clientHeight;"
' Try to find the best size for the picture
f.WriteLine "  var w, h;"
f.WriteLine "  if (myPictureList[nCurrentPic].w > myPictureList[nCurrentPic].h) {"
f.WriteLine "    w = 90 * wD / 100;"
f.WriteLine "    h = w * myPictureList[nCurrentPic].h / myPictureList[nCurrentPic].w"
f.WriteLine "  }"
f.WriteLine "  else {"
f.WriteLine "    h = 80 * hD / 100;"
f.WriteLine "    w = h * myPictureList[nCurrentPic].w / myPictureList[nCurrentPic].h"
f.WriteLine "  }"
f.WriteLine "  thePicture.width = w;"
f.WriteLine "  thePicture.height = h"
end if
if selectText <> "" then f.WriteLine "  document.myform.selectelt.selectedIndex = nCurrentPic;"
f.WriteLine "  document.getElementById(""theComment"").innerHTML = myPictureList[nCurrentPic].comment;"
f.WriteLine ""
f.WriteLine "  if (document.myform.resumeBtn.disabled) {"
f.WriteLine "    if (intervalID != null)"
f.WriteLine "      clearInterval( intervalID )"
f.WriteLine "    intervalID = setInterval( ""doSlideShow()"", 1000 * myPictureList[nCurrentPic].duration );"
f.WriteLine ""
f.WriteLine "    // Display the next picture"
f.WriteLine "    nCurrentPic = nCurrentPic + 1;"
f.WriteLine "    if (nCurrentPic >= " & nbSelPic & ")"
f.WriteLine "      nCurrentPic = 0;"
f.WriteLine "  }"
f.WriteLine "}" & vbcrlf

' Callback function called when the user click on of the buttons
f.WriteLine "function doPauseResume(bPause)"
f.WriteLine "{"
f.WriteLine "  if (intervalID != null)"
f.WriteLine "    clearInterval( intervalID )"
f.WriteLine "  if (!bPause)"
f.WriteLine "    intervalID = setInterval( ""doSlideShow()"", 1000 * myPictureList[nCurrentPic].duration );"
f.WriteLine ""
f.WriteLine "  document.myform.pauseBtn.disabled = bPause;"
f.WriteLine "  document.myform.resumeBtn.disabled = !bPause;"
f.WriteLine "}" & vbcrlf

f.WriteLine "function doRestart()"
f.WriteLine "{"
f.WriteLine "  if (document.myform.pauseBtn.disabled) {"
f.WriteLine "    document.myform.pauseBtn.disabled = false;"
f.WriteLine "    document.myform.resumeBtn.disabled = true;"
f.WriteLine "  }"
f.WriteLine "  nCurrentPic = 0;"
f.WriteLine "  doSlideShow();"
f.WriteLine "}" & vbcrlf

f.WriteLine "function doPrevNext(nStep)"
f.WriteLine "{"
f.WriteLine "  var k = nCurrentPic + nStep;"
f.WriteLine "  if (k < 0)	k += " & nbSelPic & ";"
f.WriteLine "  if (k >= " & nbSelPic & ")	k -= " & nbSelPic & ";"
f.WriteLine "  nCurrentPic = k;"
f.WriteLine "  doSlideShow();"
f.WriteLine "}" & vbcrlf

if selectText <> "" then
' Display the picture selected in the list
  f.WriteLine "function selectElement(list)"
  f.WriteLine "{"
  f.WriteLine "  var index = list.selectedIndex;"
  f.WriteLine "  nCurrentPic = parseInt( list.options[index].value );"
  f.WriteLine "  doSlideShow();"
  f.WriteLine "}" & vbcrlf
end if
f.WriteLine "// Global variables"
f.WriteLine "var nCurrentPic = 0;"
f.WriteLine "var intervalID = null;"
f.WriteLine "var myPictureList = new pictureList();"

' Process each selected picture
ixPic = 1
for i=0 to nbPic-1
  Set pic = alb.GetPicture(i)
  if pic.bSelected then

    app.Trace " Processing picture '" & pic.sFileName & "'..."
    ' Important : convert the filename so it is "web-compatible"
    Dim albFile
    ' First get the path relative to the album
    albFile = alb.ExpandMacro( pic, "%RP" )
    s = app.HTMLFileName(albFile, sAlbumPath)
    if sFirstPic = "" then sFirstPic = s
    sCmt = ""
    if bShowPicNumber then sCmt = "[" & ixPic & "/" & nbSelPic & "] "
    sCmt = sCmt & Replace( alb.ExpandMacro( pic, pictureText ), vbcrlf, "<br>" )
    sCmt = App.ConvertString( Replace( sCmt, """", "\""" ), 0 )
    ' Retrieve the duration from the picture if it is defined, if not take the
    ' default value from the album (values in 1/10 of s).
    duration = pic.lTransition and &hffff
    if duration = 65535 then duration = alb.nDelaySlideshow
    duration = replace( duration / 10, ",", ".")
    f.WriteLine "myPictureList.addPicture( new CMyPicture( """ & s & """, """ & sCmt & """, " & pic.w & ", " & pic.h & ", " & duration & " ) );"
    ixPic = ixPic + 1
  end if
next
f.WriteLine "</SCRIPT>"
f.WriteLine "</head>" & vbcrlf

f.WriteLine "<body onload=""doSlideShow()"" bgcolor=""#FFFCE0"" text=""#0000FF"" leftmargin=""0"" topmargin=""0"">"
f.WriteLine "<b><font face=""Verdana, Arial, Helvetica, sans-serif"" size=""+2"">" & sTitle & "</font></b>" & vbcrlf

f.WriteLine "<DIV id=theDiv name=theDiv style=""BACKGROUND-COLOR: #c0c0c0; TEXT-ALIGN: center"">"
f.WriteLine " <br>"
f.WriteLine " <div id=thePic name=thePic>"
f.WriteLine "   <img id=thePicture src=""" & sFirstPic & """ align=""middle"" valign=""center"" width=""90%"">"
f.WriteLine " </div>"
f.WriteLine " <H3 id=theComment name=theComment>Please wait...</H3>"
f.WriteLine "</div>" & vbcrlf

f.WriteLine "<center>"
f.WriteLine "<form id=myform name=myform>"
f.WriteLine " <input type=button value=""&lt;&lt;"" id=prev2Btn onclick=""doPrevNext(-" & nFastForwardStep & ");"">&nbsp;"
f.WriteLine " <input type=button value=""&lt;"" id=prevBtn onclick=""doPrevNext(-1);"">&nbsp;&nbsp;"
f.WriteLine " <input type=button value=""Pause"" id=pauseBtn onclick=""doPauseResume(true);"">&nbsp;&nbsp;"
f.WriteLine " <input type=button value=""Resume"" id=resumeBtn disabled onclick=""doPauseResume(false);"">&nbsp;&nbsp;"
f.WriteLine " <input type=button value=""Restart"" id=restartBtn onclick=""doRestart();"">&nbsp;&nbsp;"
f.WriteLine " <input type=button value=""&gt;"" id=nextBtn onclick=""doPrevNext(1);"">&nbsp;"
f.WriteLine " <input type=button value=""&gt;&gt;"" id=next2Btn onclick=""doPrevNext(" & nFastForwardStep & ");"">&nbsp;&nbsp;"

' Generate a combo-box that allows to chose a picture directly
if selectText <> "" then
  f.WriteLine " <SELECT ID=""selectelt"" onChange=""selectElement(this);"">"
  k = 0
  for i=0 to nbPic-1
    Set pic = alb.GetPicture(i)
    if pic.bSelected then
      f.WriteLine "   <option value=""" & k & """>" & App.ConvertString( alb.ExpandMacro( pic, selectText ), 0 ) & "</option>"
      k = k + 1
    end if
  next
  f.WriteLine " </SELECT>"
end if
f.WriteLine "</form>"
f.WriteLine "</center>" & vbcrlf

f.WriteLine "<center>Built with <a href=""http://www.myalbumpro.com"" target=_blank>MyAlbum</a></center>"
f.WriteLine "</body>" & vbcrlf & "</html>"

f.Close

app.Trace nbSelPic & " picture processed", -1, TRACE_INFORMATION
app.Trace "HTML file generation complete !", -1, TRACE_OK

' Launch browser
if nbSelPic > 0 then app.Run outputFileName, True, 0
