' ------------------------------------------------------------------------------------
'				ListFileDates.vbs
' This script will list for each picture of the current album the different dates:
'    - date stored in the album (normally the same as the last modified date),
'    - date the file was created,
'    - date the file was last modified,
'    - date the file was last accessed.
' 
' ------------------------------------------------------------------------------------

Option Explicit

app.ClearTrace

' Define the variables
dim alb, nb, i, pic, fso, f, s, datePic

set alb = app.GetCurrentAlbum
Set fso = CreateObject("Scripting.FileSystemObject")

nb = alb.nbPicture
app.Trace "Pictures in this album: " & nb
app.Trace "Picture" & vbTab  & vbTab & "   MyAlbum date" & vbTab  & vbTab & "   Created" & vbTab & vbTab & vbTab  & "   LastModified" & vbTab & vbTab & "   LastAccessed"
for i=0 to nb-1
    Set pic = alb.GetPicture(i)
    Set f = fso.GetFile( alb.ExpandMacro( pic, "%RP" ) )
    s = pic.sShortFileName
    if len( s ) < 9 then s = s & vbTab
    'if len( s ) < 16 then s = s & vbTab
    datePic = app.TimeValueToDate(pic.lFileTime)
    app.trace s & vbTab & datePic & vbTab & f.DateCreated & vbTab & f.DateLastModified & vbTab & f.DateLastAccessed

    pic.lFileTime = app.DateToTimeValue(f.DateCreated)
    set f = Nothing
next

app.Trace "Done !"

