' ------------------------------------------------------------------------------------
'			Metal_HTML_Generator.vbs
' This is a HTML generator written in VBScript that build pages having a
' somewhat "metal" look.
'
'    It uses the current album or a user specified album to build a Framed HTML file.
'    This file processes all the selected pictures.
' ------------------------------------------------------------------------------------

Option Explicit
app.ClearTrace

Dim alb, pic, albBaseFileName
set alb = app.GetCurrentAlbum
albBaseFileName = alb.ExpandMacro( alb.GetPicture(0), "%AF" )
albBaseFileName = left( albBaseFileName, instrrev( albBaseFileName, ".")-1 )
app.Trace albBaseFileName

'MsgBox( "This script will add the selected pictures to a Framed HTML page.  Please select OK to continue")
'MsgBox( "If you want alternate text to show when mouse is over the thumbnail, First fill out the Information field for each pic in the album by right mouse clicking on the pic and selecting Information.  Please select OK to continue")

Dim outputFileName
outputFileName = albBaseFileName & "_Metal.html"
app.Trace "Output file = " & outputFileName

Const ForReading = 1, ForWriting = 2

Dim fso, f, m, picPath
Set fso = CreateObject("Scripting.FileSystemObject")

' This part works and picPath is equal to the absolute path and pic file name.
' First get the path relative to the album
    Set pic = alb.GetVisiblePicture(0)
    picPath = alb.ExpandMacro( pic, "%RP" )
    app.Trace "The path for the first picture is " & picPath
    dim k, pathstring
    k = instrrev(picPath,"\") 		' Search for the last back-slash
    pathstring = left(picPath, k)
    app.Trace "The pathstring is " & pathstring

' Create the top file
    Set f = fso.OpenTextFile( pathstring & outputFileName, ForWriting, True)
    f.WriteLine "<HTML>" 
    f.WriteLine "<Head>" 
    f.WriteLine "   <META HTTP-EQUIV=""Content-Type"" CONTENT=""text/html; charset=iso-8859-1"">"
    f.WriteLine "   <META NAME=""Generator"" CONTENT=""MyAlbum"">"
    f.WriteLine "   <title>" & alb.sAlbumTitle & "</title>"
    f.WriteLine "</Head>" 
    f.WriteLine "<FRAMESET COLS=""295,*"">"
    f.WriteLine " <FRAME NAME=""select"" SRC=""" & albBaseFileName & "_Metal_index.html"" NORESIZE>"
    f.WriteLine " <FRAME NAME=""main"" SRC=""" & albBaseFileName & "_Metal_main.html"">"
    f.WriteLine "<noframes>"
    f.WriteLine "<BODY TEXT=""#000000"" BGCOLOR=""#000000"" LINK=""#0000EE"" VLINK=""#551A8B"" ALINK=""#FF0000"">"
    f.WriteLine "<p>This page requires a frames capable browser.</p>"
    f.WriteLine "</body>"
    f.WriteLine "</noframes>"
    f.WriteLine "</frameset>"
    f.WriteLine "</html>"
    app.Trace "Page " & outputfilename & " created "
    f.Close
'
' This section creates the main.html file
'
    dim mainFile
    mainFile = albBaseFileName & "_Metal_main.html"
    Set f = fso.OpenTextFile( pathstring  & mainFile, ForWriting, True)
    f.WriteLine "<HTML>"
    f.WriteLine "<HEAD>"
    f.WriteLine "   <META HTTP-EQUIV=""Content-Type"" CONTENT=""text/html; charset=iso-8859-1"">"
    f.WriteLine "   <META NAME=""Author"" CONTENT=""Pierre Meindre"">"
    f.WriteLine "   <META NAME=""Generator"" CONTENT=""MyAlbum 1.5"">"
    f.WriteLine "<TITLE>" & alb.sAlbumTitle & "</TITLE>"
    f.WriteLine "</HEAD>"
    f.WriteLine "<BODY TEXT=#FF0000 BGCOLOR=#000000>"
    f.WriteLine "<center><img src=""htmlpic/MetalTitle2.jpg""></center>"
    f.WriteLine "<script language=""Javascript"">"
    f.WriteLine "  var sSearch = document.location.search;"
    f.WriteLine "  var k = sSearch.indexOf(""="")"
    f.WriteLine "  if (k > 0) {"
    f.WriteLine "    var img = sSearch.substring( k+1, sSearch.length )"
    f.WriteLine "    var k2 = img.indexOf(""&"")"
    f.WriteLine "    if (k2>0) {"
    f.WriteLine "      sSearch = img.substring( k2, img.length );"
    f.WriteLine "      img = img.substring(0, k2);"
    f.WriteLine "    }"
    f.WriteLine "    else"
    f.WriteLine "      sSearch = """";"
    f.WriteLine "    if (k2>0) {"
    f.WriteLine "      k = sSearch.indexOf(""="");"
    f.WriteLine "      sSearch = sSearch.substring( k+1, sSearch.length );"
    f.WriteLine "      while ((k = sSearch.indexOf(""+"")) > 0)"
    f.WriteLine "	sSearch=sSearch.substring( 0, k ) + "" "" + sSearch.substring( k+1, sSearch.length )"
    f.WriteLine "	document.write( ""<h2>"" + unescape(sSearch) + ""</h2>"" );"
    f.WriteLine "      }"
    f.WriteLine "      //alert( img );"
    f.WriteLine "      var str = ""<IMG SRC=\"""" + img + ""\"" ALT=\"""" + unescape(sSearch) + ""\"" BORDER=0 width=\""100%\"">"";"
    f.WriteLine "      document.write( ""<center>"" + str + ""</center>"" );"
    f.WriteLine "    }"
    f.WriteLine "    else {"
    f.WriteLine "     document.write( ""<h3><center>Click on the thumbnails on the left to display the pictures full-size.</center></h3>"" );"
    f.WriteLine "    }"
    f.WriteLine "</script>"
    f.WriteLine "<center>Built with MyAlbum</center>"
    f.WriteLine "</BODY>"
    f.WriteLine "</HTML>"
    app.Trace "Page main.html created "
    f.Close
'
' This section creates the index.html file
'
    Set f = fso.OpenTextFile( pathstring  & albBaseFileName & "_Metal_index.html", ForWriting, True)
    f.WriteLine "<HTML>"
    f.WriteLine "<HEAD>"
    f.WriteLine "<META http-equiv=Content-Type content=""text/html; charset=windows-1252"">"
    f.WriteLine "<TITLE>" & alb.sAlbumTitle & "</TITLE>"
    f.WriteLine "</HEAD>"
    f.WriteLine "<BODY text=#ff0000 vLink=#d88e00 link=#ffa700 bgColor=#000000>"
    f.WriteLine "<table cellSpacing=0 cellPadding=0 border=0 bgColor=#808080>"
    f.WriteLine "<tr><td colspan=3><IMG src=""htmlpic/Metal100.jpg"" border=0></td></tr>"

    ' Process each selected picture
    Dim nbPic, i, kz, s
    nbPic = alb.nbVisiblePicture
    app.Trace "Pictures to process in this album: " & nbPic

    kz = 0
    s = ""
    for i=0 to nbPic-1
      Set pic = alb.GetVisiblePicture(i)
      if pic.bSelected then
	if s <> "" then f.WriteLine s
	s = ""
	' Important : convert the filename so it is web-compatible
	Dim picFile, thFile
	' First get the path relative to the album
	picFile = alb.ExpandMacro( pic, "%RP" )
	' Build the name of the thumbnail assuming "_th" is appended
	' to the name and its type is the same as the original picture
	k = instrrev( picFile, "." )
	thFile = left( picFile, k-1 ) & "_th" & mid( picFile, k )
	if kz > 0 then
	  s = s & "<tr><td colspan=3><IMG src=""htmlpic/Metal320.jpg"" border=0></td></tr>" & vbcrlf
	  s = s & "<tr><td colspan=3><IMG src=""htmlpic/Metal300.jpg"" border=0></td></tr>" & vbcrlf
	  s = s & "<tr>" & vbcrlf
	  s = s & "  <td><IMG src=""htmlpic/Metal311.jpg"" border=0></td>" & vbcrlf
	else
	  s = s & "<tr>" & vbcrlf
	  s = s & "  <td><IMG src=""htmlpic/Metal111.jpg"" border=0></td>" & vbcrlf
	end if
	s = s & "  <td"
	if pic.h > pic.w then s = s & " align=""center"""
	s = s & "><a href=""" & mainFile & "?img=" & app.HTMLFileName(picFile, pathstring ) & "&cmt=" & pic.sComment & """ target=""main"">"
	s = s & "<IMG src=""" & app.HTMLFileName( thFile, pathstring ) & """ alt=""" & pic.sComment & """ border=0"
	if pic.h > pic.w then s = s & " height=""90"""
	s = s & "></a></td>" & vbcrlf
	s = s & "  <td><IMG src=""htmlpic/Metal313.jpg"" border=0></td>" & vbcrlf
	s = s & "</tr>" & vbcrlf
	kz = kz + 1
      end if
    next
    if s <> "" then f.WriteLine Replace( s, "Metal311.jpg", "Metal411.jpg" )
    
    f.WriteLine "  <tr><td colspan=3><IMG src=""htmlpic/Metal420.jpg"" border=0></td></tr>"
    f.WriteLine "</table>"
    f.WriteLine "<center>Built with MyAlbum</center>"
    f.WriteLine "</BODY>"
    f.WriteLine "</HTML>"
    f.Close

    '
    ' Customize the title bitmap
    '
    set pic = alb.AddPicture( pathstring & "htmlpic/MetalTitle.jpg" )
    ' Write the album name on the picture
    dim rect
    Const DT_CENTER = &H1		' Centers text horizontally.
    Const DT_VCENTER = &H4		' Specifies vertically centered text (single line only).
    Const DT_NOPREFIX = &H800		' Turns off processing of prefix characters.
    const textColor = 255		' Red text
    const textBkColor = -1		' Transparent background
    const font ="LcdD,60,0,700,0,0,0"	' Change the font if this one is not avalaible on your computer
    set rect = CreateObject("MyAlbum.rect")
    rect.x = 152
    rect.y = 44
    rect.w = 384
    rect.h = 54
    pic.drawText alb.sAlbumTitle, rect, font, textColor, textBkColor, DT_VCENTER or DT_CENTER or DT_NOPREFIX

    ' Copy the whole picture to the clipboard
    pic.copy(0)
    alb.DeletePicture pic
    set pic = Nothing
    alb.paste pathstring & "htmlpic/MetalTitle2.jpg"
    set pic = alb.GetPicture( alb.nbPicture-1 )    

    app.Trace nbPic & " picture processed."
    app.Trace "HTML file generation complete !"
    app.Trace "This script creates a web page that uses thumbnail pictures in the menu."
    app.Trace "Create these from My Album Tools -> Export Album menu option."
    app.Trace "Select -Save Thumbnails- then set Output Directory to where this albums images are located, and prest Start!"

    'MsgBox( "Please read the last three lines in trace for instructions on completing this WEB page." & vbcrlf & "Please select OK to continue")

    ' Launch browser
    app.Run pathstring & outputFileName, True, 1

