' ------------------------------------------------------------------------------------
'				PanoramaApplet.vbs
'
' This script will build a web page for viewing panorama pictures using the
' ptviewer Java Applet from Professor Helmut Dersch (www.fh-furtwangen.de/~dersch/).
' Download first the applet from:  http://www.path.unimelb.edu.au/~dersch/ or from
' 	http://www.fsoft.it/panorama/ptviewer.htm
' Modify the values in the block of const(ants) to suits your configuration and needs.
' 
' ------------------------------------------------------------------------------------

Option Explicit

app.ClearTrace

'const ptviewerPath = "D:\HTML\Pano\ptviewer3.1.2.jar"	' Replace by the full path of the applet
const ptviewerPath = "M:\Images\Panorama\ptviewer.jar"	' Replace by the full path of the applet
const titleText = "%AN"					' Display String for page title
const pictureText = "%C8 - %FC (%FK KB)"		' Display String for the picture link (in the selection list)
const commentText = "%C8 - %FC<br>%C1 %LE[%C2,5]"	' Display String for the picture comment
const bShowInstruction = True				' Display a short text on how to use the applet at the bottom of the page
const pageField = "Lieu"					' 
const hotSpotField = "hotspots"					' 

Dim alb, pic, picNew, fso, f, k, nbP
set alb = app.GetCurrentAlbum

Dim sOutputPath, outputFileName, outputBaseFileName, sTitle
' Using the album folder as the default output folder
sOutputPath = alb.ExpandMacro( Nothing, "%Af" )
sOutputPath = app.GetFilename( "Select the output folder (default is the album folder)", 2, sOutputPath, "", 0 )

app.trace "Output folder is: " & sOutputPath, -1, TRACE_INFORMATION
outputBaseFileName = "index.htm" 'InputBox( "Please enter the name of the HTML file to create", "StereoscopeApplet generator", "StereoscopeApplet.html")
outputFileName = sOutputPath & "\" & outputBaseFileName
app.Trace "Output file = " & outputFileName, -1, TRACE_INFORMATION


' Copy of the ptviewer Applet java archive in the output folder
Set fso = CreateObject("Scripting.FileSystemObject")
set f = fso.GetFile( ptviewerPath )
f.copy sOutputPath & "\" & "ptviewer.jar"
set f = Nothing

Const ForReading = 1, ForWriting = 2
Dim nbPic, i, w, kR, nbSelPic, sFirstPic, s, sCmt, sFile, rcCrop, sPreviewFile, sLine
nbPic = alb.nbPicture
nbSelPic = alb.nbSelectedPicture
app.Trace "Pictures selected in this album: " & nbSelPic, -1, TRACE_INFORMATION

' First find all the pages
Dim tabPages(), tabPicPages(), nbPages, bAddPage, j
nbPages = 0
if pageField <> "" then
  for i=0 to nbPic-1
    Set pic = alb.GetPicture(i)
    if not pic is Nothing and pic.bSelected then
      s = pic.GetCustomField( pageField )
      if s <> "" then
	bAddPage = True
	for j = 0 to nbPages-1
	  if tabPages(j) = s then
	    tabPicPages(j) = tabPicPages(j) + 1
	    bAddPage = False
	  end if
	next
	if bAddPage then
	  nbPages = nbPages + 1
          redim Preserve tabPages(nbPages)
          redim Preserve tabPicPages(nbPages)
          tabPages(nbPages-1) = s
          tabPicPages(nbPages-1) = 1
        end if
      end if
    end if
  next
  app.Trace "Found " & nbPages & " pages:"
  for j = 0 to nbPages-1
    app.Trace vbTab & tabPages(j) & vbtab & tabPicPages(j) & " pictures"
  next
end if

Set f = fso.OpenTextFile( outputFileName, ForWriting, True)
f.WriteLine "<!DOCTYPE html PUBLIC ""-//W3C//DTD HTML 4.01 Transitional//EN"">"
f.WriteLine "<html>"
f.WriteLine "<head>"
sTitle = alb.ExpandMacro( Nothing, titleText )
f.WriteLine " <title>" & sTitle & "</title>"
f.WriteLine " <META HTTP-EQUIV=""Content-Type"" CONTENT=""text/html; charset=UTF-8"">"
f.WriteLine " <META NAME=""Generator"" CONTENT=""MyAlbum v" & alb.ExpandMacro( Nothing, "%MV" ) & """>"
f.WriteLine " <meta name=""description"" content=""Generated by MyAlbum. http://www.MyAlbumPro.com"">"
f.WriteLine "</head>"
f.WriteLine "<body TEXT=""#000000"" BGCOLOR=""#c0c0c0"">"

f.WriteLine "<center><h1>" & sTitle & "</h1></center>"
f.WriteLine "<center><hr><h2>"
f.WriteLine "<span id=""Cmt"" name=""Cmt"">Please wait!</span>"
'f.WriteLine " <span id=""Cmt"" name=""Cmt""><layer id=""Cmt2"" name=""Cmt2""</layer></span>"
f.WriteLine "</h2></center>"
f.WriteLine ""

f.WriteLine "<SCRIPT language=""JavaScript"">"
f.WriteLine "function CMyPicture( filename, comment, menu, pagename )"
f.WriteLine "{"
f.WriteLine "  this.length = 4;   		// Number of properties in the object, not including this one."
f.WriteLine "  this.filename = filename;	// File name (or URL) of the picture"
f.WriteLine "  this.comment  = comment;	// Comment displayed with the picture"
f.WriteLine "  this.menu  = menu;		// menu string"
f.WriteLine "  this.pagename = pagename;	// Name of the page"
f.WriteLine "}"
f.WriteLine ""
f.WriteLine "function addPicture( newPic )	// Define a function to extend the list."
f.WriteLine "{"
f.WriteLine "  this.length += 1;				// Increment the length of the array."
f.WriteLine "  this[(this.length-1)] = newPic;	// Add the new item, maintaining item numbering."
f.WriteLine "}"
f.WriteLine ""
f.WriteLine "function pictureList()"
f.WriteLine "{"
f.WriteLine "  this.length = 0;"
f.WriteLine "  this.addPicture = addPicture;   	// Include the addPicture function as a method."
f.WriteLine "}"
f.WriteLine ""
f.WriteLine "var myPictureList = new pictureList();"

k = 0
for i=0 to nbPic-1
  Set pic = alb.GetPicture(i)
  if pic.bSelected and (pic.lStatus and &hff) = TYPE_JPEG then
    'if k > 0 then f.Write "," & vbCrLf
    f.Write "myPictureList.addPicture( new CMyPicture( """ & _
    	app.HTMLFileName( alb.ExpandMacro( pic, "%RP" ), sOutputPath ) & """, """ & _
        Replace( app.ConvertString( alb.ExpandMacro( pic, commentText ), 0 ), """", "\""") & """, """ & _
        Replace( app.ConvertString( alb.ExpandMacro( pic, pictureText ), 0 ), """", "\""") & """, """
    if pageField <> "" then
      f.WriteLine pic.GetCustomField( pageField ) & """ ));"
    else
      f.WriteLine """ ));"
    end if
'    f.Write vbTab & """" & Replace( app.ConvertString( alb.ExpandMacro( pic, commentText ), 0), """", "\""") & """"
    k = k + 1
  end if
next
f.WriteLine ""

'f.WriteLine "var imageURL = new Array("
'k = 0
'for i=0 to nbPic-1
'  Set pic = alb.GetPicture(i)
'  if pic.bSelected and (pic.lStatus and &hff) = TYPE_JPEG then
'    if k > 0 then f.Write "," & vbCrLf
'    f.Write vbTab & """" & app.HTMLFileName( alb.ExpandMacro( pic, "%RP" ), sOutputPath ) & """"
'    k = k + 1
'  end if
'next
'f.WriteLine " );" & vbCRLF


f.WriteLine "function NewPano( pic ) {"
f.WriteLine "  document.ptviewer.newPanoFromList(pic);"
'f.WriteLine "  if (document.all)"
f.WriteLine "  document.getElementById(""Cmt"").innerHTML = myPictureList[pic].comment;"
'f.WriteLine "  else if (document.layers) {"
'f.WriteLine "    Cmt2.document.open();"
'f.WriteLine "    Cmt2.document.write(imageCmt[pic]);"
'f.WriteLine "    Cmt2.document.close();"
'f.WriteLine "  }"
f.WriteLine "}" & vbCRLF

f.WriteLine "function selectPicture(list) {"
f.WriteLine "  var index = list.selectedIndex;"
f.WriteLine "  index = parseInt( list.options[index].value );"
f.WriteLine "  NewPano( index );"
f.WriteLine "}" & vbCRLF

f.WriteLine "function selectThisPicture(numpic) {"
f.WriteLine "  var list = document.formBtn.selectPic;"
f.WriteLine "  list.selectedIndex = numpic;"
f.WriteLine "  index = numpic;"
f.WriteLine "  NewPano( index );"
f.WriteLine "}" & vbCRLF

if nbPages > 0 then
  f.WriteLine "function selectThisPage(list) {"
  f.WriteLine "  var index = list.selectedIndex;"
'  f.WriteLine "  index = parseInt( list.options[index].value );"
  f.WriteLine "  var page = list.options[index].value;"
  f.WriteLine "  loadPage(page);"
  f.WriteLine "}" & vbCRLF
end if

f.WriteLine "function loadPage(page) {"
f.WriteLine "  var i, s;"
f.WriteLine "  //alert(page);"
f.WriteLine "  s =  '<select id=""selectPic"" name=""selectPic"" onChange=""selectPicture(this);"">\n';"
f.WriteLine "  for (i=0; i<" & nbSelPic & "; i++) {"
f.WriteLine "    if (myPictureList[i].pagename == page) {"
' Yes, it's VBScript code generating javascript code generating HTML code...
f.WriteLine "      s += '<option value=""' + i + '"">' + myPictureList[i].menu + '</option>\n';"
f.WriteLine "    }"
f.WriteLine "  }"
f.WriteLine "  s += '</SELECT>';"
f.WriteLine "  document.getElementById(""navSelect"").innerHTML = s;"
f.WriteLine "  selectPicture(document.formBtn.selectPic);"
f.WriteLine "}" & vbCRLF

f.WriteLine "function doPrev() {"
f.WriteLine "  var list = document.formBtn.selectPic;"
f.WriteLine "  var index = list.selectedIndex;"
f.WriteLine "  if (index > 0) {"
f.WriteLine "    list.selectedIndex = index-1;"
f.WriteLine "    index = parseInt( list.options[index-1].value );"
f.WriteLine "    NewPano( index );"
f.WriteLine "  }"
f.WriteLine "}"  

f.WriteLine "function doNext() {"
f.WriteLine "  var list = document.formBtn.selectPic;"
f.WriteLine "  var index = list.selectedIndex;"
f.WriteLine "  if (index < list.length-1) {"
f.WriteLine "    list.selectedIndex = index+1;"
f.WriteLine "    index = parseInt( list.options[index+1].value );"
f.WriteLine "    NewPano( index );"
f.WriteLine "  }"
f.WriteLine "}"  

f.WriteLine "function showThisPic() {"
f.WriteLine "  var list = document.formBtn.selectPic;"
f.WriteLine "  var index = list.selectedIndex;"
f.WriteLine "  index = parseInt( list.options[index].value );"
f.WriteLine "  wnd=window.open( myPictureList[index].filename,name,""scrollbars=yes,resizable=yes,toolbar=no,status=yes,menubar=no,location=no,directories=no"");"
f.WriteLine "  wnd.focus();"
f.WriteLine "}"  

f.WriteLine "</SCRIPT>"
f.WriteLine ""

f.WriteLine "<center>"
f.WriteLine "<applet name=""ptviewer"" archive=""ptviewer.jar"" code=""ptviewer.class"" width=600 height=300 mayscript=""true"" VIEWASTEXT>"
f.WriteLine "	<param name=showToolbar value=""true"">"
f.WriteLine "	<param name=imgLoadFeedback value=""true"">"

' Process each selected picture
k = 0
Dim sFileName, sHP
for i=0 to nbPic-1
  Set pic = alb.GetPicture(i)
  if pic.bSelected and (pic.lStatus and &hff) = TYPE_JPEG then
    s = pic.GetCustomField( "hfov" )
    if s <> "" and s <> "360" then
      s = " {pfov=" & s & "}"
    else
      if s = "360" then 'and pic.w = 2*pic.h then
        s = " {fov=100}"
      else
        s = ""
      end if
    end if
    app.Trace "  Processing picture '" & pic.sShortFileName & "'..."
    sFileName = app.HTMLFileName( alb.ExpandMacro( pic, "%RP" ), sOutputPath )
    if Left( sFileName, 2 ) = ".." or InStr( sFileName, ":///" ) <> 0 then app.Trace vbTab & "Caution: PTViewer may not be able to load this picture.", -1, TRACE_WARNING
    sHP = buildHotSpot( pic )
    if sHP <> "" then s = s & " " & sHP
    f.WriteLine "    <param name=Pano" & k & " value="" {file=" & sFileName & "}" & s &""">"    
    k = k + 1
  end if
next 
f.WriteLine "</applet>"
'f.WriteLine "<br>"
f.WriteLine ""

f.WriteLine "<hr>"
'f.WriteLine "<INPUT TYPE=""button"" width=100 value=""Castle"" onClick=""document.ptviewer.gotoView(161.0, 28, 30.0)"">"
'f.WriteLine "<br>"

f.WriteLine "<form id=formBtn name=formBtn>"
if nbPages > 0 then
  f.WriteLine "<select id=""selectPage"" name=""selectPage"" onChange=""selectThisPage(this);"">"
  for j = 0 to nbPages-1
    f.WriteLine "  <option value=""" & tabPages(j) & """>" & tabPages(j) & " (" & tabPicPages(j) & ")</option>"
  next
  f.WriteLine "</select><br>"
end if

f.WriteLine "<INPUT TYPE=""button"" width=100 value=""<<"" onClick=""javascript:doPrev()"">"
f.WriteLine "<SPAN id=navSelect>"
f.WriteLine "<select id=""selectPic"" name=""selectPic"" onChange=""selectPicture(this);"">"

k = 0
nbP = 0
for i=0 to nbPic-1
  Set pic = alb.GetPicture(i)
  if pic.bSelected and (pic.lStatus and &hff) = TYPE_JPEG then
'    f.WriteLine "  <option value=""" & k & """>" & app.ConvertString( alb.ExpandMacro( pic, pictureText ), 0 ) & "</option>"
    'f.WriteLine "<INPUT TYPE=""button"" width=100 value=""" & alb.ExpandMacro( pic, pictureText ) & """ onClick=""javascript:NewPano(" & k & ")"">"
    k = k + 1
    nbP = nbP + 1
  end if
next
f.WriteLine "</select></span>"
f.WriteLine "<INPUT TYPE=""button"" width=100 value="">>"" onClick=""javascript:doNext()"">"

f.WriteLine "<br><br><INPUT TYPE=""button"" width=100 value=""AutoPan"" onClick=""document.ptviewer.startAutoPan(0.5,0,1)"">"
'f.WriteLine "<INPUT TYPE=""button"" width=100 value=""Left"" onClick=""document.ptviewer.panLeft()"">"
'f.WriteLine "<INPUT TYPE=""button"" width=100 value=""Move"" onClick=""document.ptviewer.moveFromTo(10.0, 50.0, 0.0, 20.0, 50.0, 90.0, 200)"">"
f.WriteLine "<br><INPUT TYPE=""button"" width=100 value=""Display picture in new window"" onClick=""javascript:showThisPic()"">"
f.WriteLine "</form>"
f.WriteLine "</center>" & vbCRLF

if bShowInstruction then
  f.WriteLine "<table border=0>"
  f.WriteLine "<tr><td colspan=2 valign=top><font face=""Arial,Swiss"" size=-1><b><u>Instructions:</u></b></td></tr>"
  f.WriteLine "<tr><td>"
  f.WriteLine "<UL>"
  f.WriteLine "<LI>Click and move the mouse to pan and tilt.</LI>"
  f.WriteLine "<LI>While panning, use the Ctrl and/or Shift keys to zoom in and out.</LI>"
  f.WriteLine "<LI>Alternatively, use the arrow keys for panning and tilting in fixed increments.</LI>"
  f.WriteLine "</ul>"
  f.WriteLine "</td>"
  f.WriteLine "<td>"
  f.WriteLine "<LI>Use + and -, or &gt; and &lt; keys to zoom in fixed increments.</LI>"
  f.WriteLine "<LI>Press the space bar to make show or hide the hotspots.</LI>"
  f.WriteLine "<LI>While over hotspot, click the mouse or press Enter to jump to link.</LI>"
  f.WriteLine "</UL></font>"
  f.WriteLine "</td>"
  f.WriteLine "</tr>"
  f.WriteLine "</table>"
end if

f.WriteLine "<hr>" & vbcrlf & "<center>Built with <a href=""http://myalbumpro.com"" target=""_blank"">MyAlbum</a> script</center>"
f.WriteLine "<SCRIPT FOR=window EVENT=onload LANGUAGE=""javascript"">"
f.WriteLine "  // Display the first picture when all is loaded (especially the applet)"
if nbPages > 0 then
  f.WriteLine "  selectThisPage( document.formBtn.selectPage );"
else
  f.WriteLine "  loadPage('');"
  f.WriteLine "  NewPano( 0 );"
end if
f.WriteLine "</SCRIPT>"
f.WriteLine "</body>"
f.WriteLine "</html>"

f.Close

app.Trace ""
app.Trace nbP & " pictures processed."
app.Trace "HTML file generation complete !", -1, TRACE_GREENDOT

' Launch browser
''''if nbP > 0 then app.Run outputFileName, True, 0


' ------------------------------------------------------------------------------------
function buildHotSpot(pic)
  buildHotSpot = ""
  dim s, iSpot, TSpot, i, k, TF
  s = pic.GetCustomField( hotSpotField )
  iSpot = 0
  TSpot = Split( s, ";", -1, 1 )
  k = UBound(TSpot)
  if k < 0 then exit function
  for i = 0 to k
    'app.Trace TSpot(i), &hff0000
    TF = Split( TSpot(i), ",", -1, 1 )
    if UBound(TF) = 2 then
      'if iSpot = 0 then buildHotSpot = ""
      buildHotSpot = buildHotSpot & " {hotspot" & iSpot & "=X" & TF(1) & " Y" & TF(2) & " u'javascript:selectThisPicture(" & findPicNum(TF(0)) & ")'}"
      iSpot = iSpot + 1
    else
      app.Trace "Caution: Badly written hotspot: '" & TSpot(i) & "'", 255, TRACE_WARNING
    end if
  next
end function

' ------------------------------------------------------------------------------------
function findPicNum(picName)
  findPicNum = 0
  dim i, pic
  for i=0 to nbPic-1
    Set pic = alb.GetPicture(i)
    if pic.bSelected then
      if picName = pic.sShortFileName then exit function
      findPicNum = findPicNum + 1
    end if
  next
  app.Trace "Caution: Cannot find hotspot picture: '" & picName & "'", 255, TRACE_WARNING
end function
