' ------------------------------------------------------------------------------------
'              PhotoPC
' Demo of the PhotoPC MAX extension
' Take 3 photos and add them to the current album
' ------------------------------------------------------------------------------------
Option Explicit

' Define the variables
dim alb, nb, i, pic

app.ClearTrace
set alb = app.GetCurrentAlbum

dim maxx, s, sFile, numP
nb = app.nbMAX
app.Trace "MAX extensions loaded: " & nb
for i = 0 to nb-1
  set maxx = app.GetMaxByNum(i)
  app.trace "Max#" & i+1 & " = " & maxx.name
next


set maxx = app.GetMax("Max_PhotoPC")

' Display camera info
exec "query"
msgbox maxx.getresult()

exec "resolution Lo" ' Caution this may be a camera dependent command

for i=1 to 3
  app.trace "Taking picture #'" & i
  sFile = "c:\temp\Pic" & i & ".jpg"
  exec "snapshot"
  exec "count"
  numP = val(maxx.getresult())
  app.trace "Picture=" & numP
  exec "image " & numP & " " & sFile
  exec "erase " & numP 
  alb.addPicture( sFile )
  alb.redraw
next

app.Trace "Done !"

' Execute a PhotoPC command and wait for termination
Function Exec( s )
  dim bOK
  app.trace "  Execution command '" & s & "'"
  bOK = maxx.execute( s )
  do
    app.wait 250
    'app.trace "Waiting... (" & s & ")"
  loop until maxx.nState=0
  Exec = bOK
End Function

Function val( s )
  dim num, i, n
  num = 0
  n = len(s)
  for i=1 to n
    if mid(s,i,1) >= "0" and mid(s,i,1) <= "9" then num = 10*num + asc(mid(s,i,1)) - 48
  next
  val = num
End Function
