#-------------------------------------------------------------
#                         PictureDelay.pls
#  List for each picture in the album its display time
#    or
#  Reset the display time for all the pictures in the album
#-------------------------------------------------------------

# Some constants...
use constant vbYesNo => 4;
use constant vbQuestion => 32;
use constant vbYes => 6;
use constant ValClear => 0xffff;  # 0xffff = use album-level value

$App->ClearTrace();
$alb = $App->GetCurrentAlbum;
if ($alb == undef) {
  $App->Trace( "No album, exiting!" );
  exit;
}
$nb = $alb->nbVisiblePicture;
if ($nb == 0) {
  $App->Trace( "No pictures, exiting!" );
  exit;
}

$s = "Picture delay.\nDo you want to:\n   <Yes> clear the delay,\n   <No> list the values ?";
$bClear = (vbYes == MsgBox( $s, vbYesNo + vbQuestion, "PictureDelay" ));

$App->Trace( "Pictures in this album: $nb" );
$App->Trace( "  Clearing the delay for all the displayed pictures..." ) if ($bClear);

for ($i = 0; $i < $nb; $i++) {
  $pic = $alb->GetVisiblePicture($i);
  if ($bClear) {
    # The delay is in the lower WORD of the lTransition property
    $d = ($pic->lTransition & !65535) + ValClear;
    $pic->{lTransition} = $d;
  }
  else {
    $d = $pic->lTransition & 65535;
    if ($d == 65535) {
      $s = "<default album value>";
    }
    else {
      $d = $d / 10.;
      $s = "$d s";
    }
    $text = $i+1 . "\t" . $pic->sShortFileName . "\t";
    # Trying to align the columns...
    $n = length($pic->sShortFileName);
    for ($k = 0; $k < 2 - $n/10; $k++) {
      $text .= "\t";
    }
    $App->Trace( $text . $s );
  }
}

# Set the modified flag for the album if we have modified the delays
$alb->{Saved} = False if ($bClear);

$App->Trace( "Done !" );
