//		RenameToDate.js
// Rename all selected pictures to the Custom Fields date and time
// filled from the EXIF header (YYYY.MM.DD-HH.MM.SS.xxx)
// Gottfried Koschel

App.ClearTrace();

// Change to the actual names of the "Date" and "Time" Custom Fields
var dateField= "Datum";
var timeField= "Uhrzeit";

var alb= App.GetCurrentAlbum();

nb= alb.nbVisiblePicture;
for (i= 0; i< nb; i++) {
    pic= alb.GetVisiblePicture(i);
    if (pic.bSelected== 1) {
        oldFilename= pic.sFileName;
        index= oldFilename.lastIndexOf(".");
        oldExtension= oldFilename.substring(index, oldFilename.length);
        index= oldFilename.lastIndexOf("\\");
        oldPath= oldFilename.substring(0, index);

        yDate= pic.GetCustomFieldDate(dateField);
        time= pic.GetCustomFieldDate(timeField);
        if (yDate== 0 || time== 0) {
            App.trace("defined userfield not found");
            continue;
        }
        millis= 1000* (yDate+ time);
        date= new Date();
        date.setTime(millis);
        yr= date.getUTCFullYear();
        mt= date.getUTCMonth()+ 1;
        sMt= ((mt< 10) ? "0"+ mt: mt);
        dy= date.getUTCDate();
        sDy= ((dy< 10) ? "0"+ dy: dy);
        hr= date.getUTCHours();
        sHr= ((hr< 10) ? "0"+ hr: hr);
        mn= date.getUTCMinutes();
        sMn= ((mn< 10) ? "0"+ mn: mn);
        sc= date.getUTCSeconds();
        sSc= ((sc< 10) ? "0"+ sc: sc);

        newFilename= yr+ "."+ sMt+ "."+ sDy+ "-"+ sHr+ "."+ sMn+ "."+ sSc+ oldExtension;
        newFullname= oldPath+ "\\"+ newFilename;

        fso= new ActiveXObject("Scripting.FileSystemObject");
        try {
            file= fso.GetFile(oldFilename);
            file.Name= newFilename;

            pic.sFileName= newFullname;
            App.trace(oldFilename+ " -> "+ newFilename);
        }
        catch (e) {
            App.trace(oldFilename+ " -> "+ newFilename+ " Error: "+ e);
        }
    }
}
alb.ReDraw();

App.trace( "Done !" );

