#--------------------------------------------------------------------------
#			ScriptDisplayString.pls
# This script is an example of user defined Display String generation.
# The use the macro code %SF will call a function with the following
# parameters:
#	- a reference to the current album (an "Album" object),
#	- a reference to the current picture (a "Picture" object),
#	- an integer value (unused, reserved for future use).
# The function returns a string containing the generated text.
# Note: loading and executing a script function can be slow, this macro
# should be used for Display Strings used for printing and HTML generation
# rather than screen display.
# This example computes the amount of megapixel the picture contains.
# The %SF macro needs two parameters: the script file (use a complete path)
# and the name of the function to call:
#	%SF["ScriptDisplayString.pls",MegaPixels]
#--------------------------------------------------------------------------

use constant MEGAPIX => 1000000;
#$App->ClearTrace;

sub MegaPixels
{
  local ($zAlb, $zPic) = @_;
  #$App->Trace( ">> MegaPixels called !!!" );
  if (!defined( zPic)) {
    return ">no pic !<";
  }
  my $nbPx = ($zPic->w * $zPic->h) / MEGAPIX;

  # Important: ensure that the returned value is a string
  return int(10 * $nbPx +0.5)/10 . " Megapixel";
}
