// ------------------------------------------------------------
//			Xara3D-renderurl.js
// JScript calling the "Xara 3D Graphics Generator" WebService
// to generate a 3d caption.
// Code based on "renderurl.js" from xara (www.xara.com).
// SOAP toolkit runtime needed.
// ------------------------------------------------------------

App.ClearTrace();

var WRAPPER_ELEMENT_NAMESPACE = "http://soap.xara.com/message/";
var END_POINT_URL = "http://ws.xara.com/graphicrender/render3d.asp"
var Result = RenderURL("Static9" /*"Calligraphic2"*/, "This is MyAlbum!", "660099", "FFFFFF", "DicotMedium Regular", "172", "jpg", 0, 0);

var sTempFile = "d:\\temp\\testXara.jpg";
var alb = App.GetCurrentAlbum();

if (Result.substr(0, 7) == "http://") {
    App.Trace( "Generated graphic: " + Result );
    //App.Run( Result, true, 1 );
    App.Trace( "Retrieving picture..." );
    if (App.HTTPGet( Result, sTempFile ) == 0) {
        App.Trace( "Adding picture " + sTempFile );
        alb.AddPicture( sTempFile );
        alb.Redraw();
    }
    App.Trace( "Done!" );
}
else
    App.Trace( "Cannot invoke web service." );

function RenderURL(templ, text, textcol, bgcol, font, fsize, exptype, width, height)
{
    var EndPointURL = END_POINT_URL;
    var Method = "RenderURL";
    var Serializer;
    var Reader;
    var Connector;

    App.Trace("Connecting: " + END_POINT_URL);

    Connector = new ActiveXObject("MSSOAP.HttpConnector");
    Connector.Property("EndPointURL") = EndPointURL;

    Connector.BeginMessage();

    Serializer = new ActiveXObject("MSSOAP.SoapSerializer");
    Serializer.Init(Connector.InputStream);

    Serializer.startEnvelope();
    Serializer.startBody();
    Serializer.startElement(Method, WRAPPER_ELEMENT_NAMESPACE, "", "m");
    Serializer.startElement("Template");
    Serializer.writeString(templ);
    Serializer.endElement();
    Serializer.startElement("Text");
    Serializer.writeString(text);
    Serializer.endElement();
    Serializer.startElement("TextColor");
    Serializer.writeString(textcol);
    Serializer.endElement();
    Serializer.startElement("BGColor");
    Serializer.writeString(bgcol);
    Serializer.endElement();
    Serializer.startElement("Font");
    Serializer.writeString(font);
    Serializer.endElement();
    Serializer.startElement("FontSize");
    Serializer.writeString(fsize);
    Serializer.endElement();
    Serializer.startElement("ExportType");
    Serializer.writeString(exptype);
    Serializer.endElement();
    Serializer.endElement();
    Serializer.endBody();
    Serializer.endEnvelope();

    Connector.EndMessage();

    Reader = new ActiveXObject("MSSOAP.SoapReader");
    Reader.Load(Connector.OutputStream);

    if (Reader.Fault == null) {
	var node = Reader.RPCResult
	while (node != null) {
	    App.Trace( " " + node.nodeName + "=" + node.text );
	    node = node.nextSibling
	}
	return Reader.RPCResult.text;
    }
    else
	return "Error: " + Reader.faultstring.text;
}

